<?php
    @session_start();
    @include_once("Security.php");
    @include_once("DataBase.php");
    @include_once("UserManager.php");
    @include_once("MenuManager.php");
    @include_once("LanguageManager.php");
    @include_once("DataHelp.php");
    @include_once("FileManager.php");
    @include_once("ImageManager.php");
    @include_once("SendMail.php");
    @include_once("Paginator.php");
    @include_once("Permissions.php");
    
    class Cuppa{
        private static $instance;
        public $configuration;
        public $dataBase;
        public $security;
        public $user;
        public $menu;
        public $language;
        public $dataHelp;
        public $file;
        public $image;
        public $mail;
        public $paginator;
        public $permissions;
        public function Cuppa($reload = true){
            @session_start();
            if(!@$_SESSION["cuSession"]) @$_SESSION["cuSession"] = new stdClass();
            $this->language = LanguageManager::getInstance();
            $this->dataHelp = new DataHelp();
            $this->file = new FileManager();
            $this->image = new ImageManager();
            $this->security = Security::getInstance();
            @include_once realpath(__DIR__ . '/..')."/Configuration.php";
            $this->configuration = new Configuration();
            //++ validate SSL active
                if(@$this->configuration->ssl){
                    if(!isset($_SERVER['HTTPS']) || $_SERVER['HTTPS'] == ""){
                        $redirect = "https://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
                        header("Location: $redirect");
                    }
                }
            //--
            //++ auto set admin [path], [document_path]
                if($reload){
                    if(@$this->configuration->base_admin_url){
                        $this->setPath($this->configuration->base_admin_url);
                    }else{
                        $dir = array_values(array_filter(explode("/",str_replace(array("\\", "classes"), array("/", ""), __DIR__))));
                        $dir = "/".array_pop($dir)."/";
                        $admin_path_string =  $this->setPath();
                        $admin_path = array_values((array_filter(explode("/",$admin_path_string))));
                        if(strpos($admin_path_string, $dir) !== false){
                            $path = substr($admin_path_string, 0, strpos($admin_path_string, $dir) ).$dir;
                            $this->setPath($path);
                        }else{
                            $path = $admin_path_string.str_replace("/","", $dir)."/";
                            $this->setPath($path);
                        }
                    }
                    $this->setDocumentPath(realpath(__DIR__ . '/..')."/");
                    $this->security->createSecurityData();
                }
            //--
            $this->init();
        }
        public static function getInstance($reload = false){
            @session_start();
            if(!$reload && self::$instance == null){ 
                if(!@$_SESSION['cuSession']->token || !@$_SESSION['cuSession']->sessionKey){
                    echo "<script> window.location.href = ''; </script>";
                    exit();
                };
            }
			if (self::$instance == NULL) { self::$instance = new Cuppa($reload); }
			return self::$instance;
		}
        // init
            public function init(){
                @session_start();
                $this->mail = new SendMail(); $this->mail->configure();
                $this->dataBase = DataBase::getInstance($this->configuration->db, $this->configuration->host, $this->configuration->user, $this->configuration->password);
                $this->user = UserManager::getInstance();
                $this->user->setUnregisteredUser();
                $this->menu = MenuManager::getInstance();
                $this->paginator = new Paginator();
                $this->permissions = Permissions::getInstance();
            }
        // Define access paths
            public function setPath($path = null, $name = "administrator"){
                @session_start();
                if(!isset($_SESSION['cuSession']->paths)) @$_SESSION['cuSession']->paths = new stdClass();
                $_SESSION['cuSession']->paths->$name = new stdClass();
                // Create Root
                    if(!$path){
                        if(@$_SERVER["SCRIPT_NAME"]) $path = "http://".@$_SERVER["HTTP_HOST"].@$_SERVER["SCRIPT_NAME"];
                        else if(@$_SERVER["REQUEST_URI"]) $path = "http://".@$_SERVER["HTTP_HOST"].@$_SERVER["REQUEST_URI"];
                        else $path = "http://".@$_SERVER["HTTP_HOST"].@$_SERVER["PHP_SELF"];
                        if($this->configuration->ssl){$path =  str_replace("http", "https", $path); }
                        $path = $this->dataHelp->cutText("?", $path, 9999,"", true);
                        $path = $this->dataHelp->cutText("/", $path, 9999, "/", true);
                    }
                    if($name == "administrator"){
                        $path = str_replace("administrator/administrator","administrator",$path);
                    }
                    $_SESSION['cuSession']->paths->$name->path = $path;
                    // Auto create Document Root
                        $this->setDocumentPath("", $name);
                return $path;
            }
        // Get Document path by name
            public function setDocumentPath($document_path = "", $name = "administrator"){
                if(!$document_path){
                    if(@$_SERVER["SCRIPT_NAME"]){
                        $document_path = @$_SERVER['DOCUMENT_ROOT'] . @$_SERVER["SCRIPT_NAME"];
                    }else if(@$_SERVER["REQUEST_URI"]){
                        $document_path = @$_SERVER['DOCUMENT_ROOT'] . @$_SERVER["REQUEST_URI"];
                    }else{
                        $document_path = @$_SERVER['DOCUMENT_ROOT'] . @$_SERVER["PHP_SELF"];
                    }
                }
                $document_path = $this->dataHelp->cutText("?", $document_path, 9999, "", true);
                $document_path = $this->dataHelp->cutText("/", $document_path, 9999, "/", true);
                $document_path = str_replace("\\", "/", $document_path);
                $_SESSION['cuSession']->paths->$name->document_path = $document_path;
            }
        // Get Path by name
            public function getPath($name = "administrator"){
                return @$_SESSION['cuSession']->paths->$name->path;
            }
        // Get Document path by name
            public function getDocumentPath($name = "administrator"){
                return @$_SESSION['cuSession']->paths->$name->document_path;
            }
        // Set session var
            public function setSessionVar($name, $value){
                @session_start();
                if(!@$_SESSION['cuSession']) @$_SESSION['cuSession'] = new stdClass();
                $_SESSION['cuSession']->$name = $value;
            }
        // Get session var
            public function getSessionVar($name){
                @session_start();
                return @$_SESSION['cuSession']->$name;
            }
        // echo String
            public function echoString($string, $special = true, $document_root = ""){
                if($special){
                    echo $this->dataHelp->echoSpecialString($string, $document_root);
                }else{
                    echo htmlspecialchars(trim($string));
                }
            }
        // santize String
            public function sanitizeString($string){
                return htmlspecialchars(trim(@$string));
            }
        // get
            public function GET($string){
                return $this->sanitizeString(@$_GET[$string]);
            }
        // post
            public function POST($string){
                return $this->sanitizeString(@$_POST[$string]);
            }
        // request
            public function REQUEST($string){
                return $this->sanitizeString(@$_REQUEST[$string]);
            }
        // JSON Endoce
            function jsonEncode($value, $base64_encode = true){
                $value = json_encode($value);
                if($base64_encode) $value = base64_encode($value);
                return $value;
            }
        // JSON Decode
            function jsonDecode($value, $base64_decode = true){
                if($base64_decode) $value = base64_decode($value);
                $value = json_decode($value);
                return $value;
            }
        // Encript / Decript
            function encrypt($string, $key = "", $key2 = ""){
                if(!$string) return false;
                if(!$key) $key = $this->configuration->global_encode_salt;
                if(!$key2) $key2 = $this->security->sessionKey;
                $crypttext = mcrypt_encrypt(MCRYPT_RIJNDAEL_256, $key, $string, MCRYPT_MODE_ECB, $key2);
                return trim(base64_encode($crypttext));
            }
            function decrypt($string, $key = "", $key2 = ""){
                if(!$string) return false;
                if(!$key) $key = $this->configuration->global_encode_salt;
                if(!$key2) $key2 = $this->security->sessionKey;
                $crypttext = base64_decode($string);
                $decrypttext = mcrypt_decrypt(MCRYPT_RIJNDAEL_256, $key, $crypttext, MCRYPT_MODE_ECB, $key2);
                return trim($decrypttext);
            }
        // Encript / Decript ID's
            // Example: $cuppa->encryptIds(987654);
            // To Decript: $cuppa->encryptIds('encripted', true);
            function encryptId($in, $to_num = false, $base64 = false, $pad_up = false, $pass_key = null){
                if(!$pass_key) $pass_key = $this->security->getToken();
                if($to_num && $base64) $in = base64_decode($in);
            	$out   =   ''; $index = 'abcdefghijklmnopqrstuvwxyz0123456789'; $base = strlen($index);
            	if ($pass_key !== null) {
            		for ($n = 0; $n < strlen($index); $n++) { $i[] = substr($index, $n, 1); }
            		$pass_hash = hash('sha256',$pass_key);
            		$pass_hash = (strlen($pass_hash) < strlen($index) ? hash('sha512', $pass_key) : $pass_hash);
            		for ($n = 0; $n < strlen($index); $n++) { $p[] =  substr($pass_hash, $n, 1); }
            		array_multisort($p, SORT_DESC, $i);
            		$index = implode($i);
            	}
            	if ($to_num) {
            	   $len = strlen($in) - 1;
            	   for ($t = $len; $t >= 0; $t--) {
            			$bcp = bcpow($base, $len - $t);
            			$out = $out + strpos($index, substr($in, $t, 1)) * $bcp;
           		   }
            	   if (is_numeric($pad_up)) {
            	   	   $pad_up--;
            	       	if ($pad_up > 0) { $out -= pow($base, $pad_up); }
           		   }
            	} else {
            		if (is_numeric($pad_up)) {
            			$pad_up--;
            			if ($pad_up > 0) { $in += pow($base, $pad_up); }
            		}
            		for ($t = ($in != 0 ? floor(log($in, $base)) : 0); $t >= 0; $t--) {
            			$bcp = bcpow($base, $t);
            			$a   = floor($in / $bcp) % $base;
            			$out = $out . substr($index, $a, 1);
            			$in  = $in - ($a * $bcp);
            		}
                    if($base64) $out =  base64_encode($out);
            	}
            	return $out;
            }
        // Get adminisrtator directory
            function administratorFolder(){
                $dir = array_values(array_filter(explode("/",str_replace(array("\\", "classes"), array("/", ""), __DIR__))));
                $dir = array_pop($dir);
                return $dir;
            }
        // Cookie
            function setCookie($name, $value = null){
                $expire_time = time() + (10 * 365 * 24 * 60 * 60);
                setcookie($name, $value, $expire_time, '/');  
            }
            function getCookie($name){
                return $this->sanitizeString(@$_COOKIE[$name]);
            }
        // ip
            function ip(){
                $ip = "";
                if (!empty($_SERVER['HTTP_CLIENT_IP'])){ $ip = $_SERVER['HTTP_CLIENT_IP']; }
                else if (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])){ $ip = $_SERVER['HTTP_X_FORWARDED_FOR']; }
                else { $ip = $_SERVER['REMOTE_ADDR']; }
                return $ip;
            }
        // language value righ
            public function langValueRich($label, $return_all = false, $return_column = "content"){
                return $this->language->getValueRich($label, $return_all, $return_column);
            }
            public function langValue($key = "", $language_file_reference = "administrator", $convert_to_url_friendy = false){
                return $this->language->getValue($key, $language_file_reference, $convert_to_url_friendy);
            }
        // Curl
            public function curl($str){
                $data = explode("\\", $str);
                $url = trim(substr($data[0], strpos($data[0],"http"))); array_shift($data);
                $curl = curl_init();
                        curl_setopt($curl, CURLOPT_URL, $url);
                        curl_setopt($curl, CURLOPT_HEADER, false);
                        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
                        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true); 
                        curl_setopt($curl, CURLOPT_POST, true);
                        curl_setopt($curl, CURLOPT_TIMEOUT, 10);
                
                $array_header = array();
                $data_array = array();
                //++ Analyze
                    for($i = 0; $i < count($data); $i++){
                        $row = trim($data[$i]);
                        if(strpos($row,"-u") !== false){                // user:password
                            $row = trim(str_replace("-u", "",$row));
                            $row = str_replace(array("'", '"'), array("", ""), $row);
                            curl_setopt($curl, CURLOPT_USERPWD, $row);
                        }else if(strpos($row, "-d") !== false ){        // post data
                            $row = trim(str_replace("-d", "",$row));
                            if(strpos($row, "]=") !==  false ){
                                $row = str_replace(array('"', "'"), array("", ""), $row);
                                $row = explode("=", $row);
                                $key = @$row[0]; $value = @$row[1];
                                $data_array[$key] = $value;
                            }else{
                                array_push($data_array, $row);
                            }
                        }else if(strpos($row, "-H") !== false ){
                           $row = trim(str_replace("-H", "",$row));
                           array_push($array_header, $row);
                        }
                    }
                    // Add Header
                        curl_setopt($curl, CURLOPT_HTTPHEADER, $array_header);
                    // Add Data
                        if(count($data_array) < 2) $data_array = @$data_array[0];
                        curl_setopt($curl, CURLOPT_POSTFIELDS, $data_array);
                //--
                
                $res = curl_exec($curl); curl_close($curl);
                print_r($res);
            }
        
    }
?>