<?php
    @session_start();
    if(!@$_SESSION["cuSession"]){ echo '<script> window.location=document.URL; </script>'; exit(); }
    include_once($_SESSION["cuSession"]->paths->administrator->document_path."classes/Cuppa.php");
    $cuppa = Cuppa::getInstance();
    $language = $cuppa->language->load("web");
    $sql = "SELECT po.*, pi.image, pi.alias FROM ex_google_points as po JOIN ex_google_pins as pi ON po.pin = pi.id
            WHERE po.enabled = 1 AND (po.language = '' OR po.language = '".$cuppa->language->current()."')";
    $points = $cuppa->dataBase->PersonalSql($sql, $cuppa->security->token, true);
?>
<script>
    MapClass = {}
    MapClass.pins = jQuery.parseJSON(jQuery.base64Decode('<?php echo base64_encode(json_encode($points)) ?>'));
    MapClass.principal_point = null;
    MapClass.state_pins = {};   // {pin1:false, pin2:false} = false, no showed. true, showed.
    //++ Init
        MapClass.init = function(){
            // Map styles
                var styles= [ 
                    { featureType: "all", stylers: [ { saturation: -80 }]},
                    { featureType: "road.arterial", elementType: "all", stylers: [ { saturation: -100 }, { lightness: -30 }, { visibility: "on" } ]},
                    { featureType: "road.highway", elementType: "all", stylers: [ { saturation: -100 }, { lightness: -5 }, { visibility: "on" } ] },
                    { featureType: "poi.business", elementType: "labels", stylers: [ { visibility: "off" } ] }
                ];
            // Get Principal point
                for ( var i = 0; i < MapClass.pins.length; i++ ) { if(MapClass.pins[i].principal_point == "1"){ MapClass.principal_point = MapClass.pins[i]; break } };
            // Set all alias aviables
                for ( var i = 0; i < MapClass.pins.length; i++ ) {
                    if(MapClass.pins[i].principal_point != "1"){
                        MapClass.state_pins[MapClass.pins[i].alias] = false;
                    }
                };
            // Options
                var options = {}
                    options.center = new google.maps.LatLng(MapClass.principal_point.latitude, MapClass.principal_point.longitude);
                    options.zoom = 15;
                    options.mapTypeId = google.maps.MapTypeId.ROADMAP;
                    options.disableDefaultUI = true;
                    //options.styles = styles;
            // Map
               map = new google.maps.Map(jQuery("#map-canvas")[0], options);
            // Set Markers / Apartament
                MapClass.setMarkers();
            // Events
                jQuery(".buttom_pin").bind("mouseenter", MapClass.onOver).bind("mouseleave", MapClass.onOut);
        }; jQuery(document).ready(MapClass.init);
    //--
    // Markers
        MapClass.markers = {}
        MapClass.infoWindows = {};
        MapClass.setMarkers = function(alias, show){
            if(alias == undefined) alias = MapClass.principal_point.alias;
            if(show == undefined) show = true;
            for ( var i = 0; i < MapClass.pins.length; i++ ) {
                if(MapClass.pins[i].alias == alias && show){
                    try{ MapClass.markers["marker_"+i].setMap(null); MapClass.markers["marker_"+i] = null; }catch(err){}
                    var marker_options = {}
                        marker_options.position = new google.maps.LatLng(MapClass.pins[i].latitude, MapClass.pins[i].longitude);
                        marker_options.map = map;
                        marker_options.icon = "<?php echo $cuppa->getPath() ?>" + MapClass.pins[i].image;
                        marker_options.name = "marker_" + i;
                        marker_options.alias = alias;
                        marker_options.animation = google.maps.Animation.DROP;
                    MapClass.markers["marker_"+i] = new google.maps.Marker(marker_options);
                    MapClass.infoWindows["marker_"+i] = new google.maps.InfoWindow({ maxWidth: 300, content: contentString = "<div class='map_info_title'>"+MapClass.pins[i].title+"</div><div class='map_info_description'>"+MapClass.pins[i].description+"</div>" });
                    google.maps.event.addListener(MapClass.markers["marker_"+i], 'mouseover', function() { MapClass.infoWindows[this.name].open(map,MapClass.markers[this.name]); });
                    google.maps.event.addListener(MapClass.markers["marker_"+i], 'mouseout', function() { MapClass.infoWindows[this.name].close(map,MapClass.markers[this.name]); });
                }else if(MapClass.pins[i].alias == alias && !show){
                    try{ MapClass.markers["marker_"+i].setMap(null); MapClass.markers["marker_"+i] = null; }catch(err){}
                }
            }
        }
    // Events
        MapClass.onClick = function(alias){
            MapClass.state_pins[alias] = (MapClass.state_pins[alias]) ? false : true;
            MapClass.setMarkers(alias, MapClass.state_pins[alias]);
        }
    // MouseOver
        MapClass.onOver = function(e){
            var item = e.currentTarget;
            var y = jQuery(item).css("background-position").split(" "); y = y[y.length-1];
            TweenMax.to(item, 0.4, { "backgroundPosition": "right "+y, ease:Cubic.easeOut });
            MapClass.tooltip.showTooltip(item, true, 5, 10)
        };
        MapClass.onOut = function(e){
            var item = e.currentTarget;
            var y = jQuery(item).css("background-position").split(" "); y = y[y.length-1];
            TweenMax.to(item, 0.2, { "backgroundPosition": "0px "+y, ease:Cubic.easeOut });
            MapClass.tooltip.showTooltip(item, false)
        }
    // zoom
        MapClass.onZoom = function(value){
            if(value == "+") map.setOptions({zoom:map.zoom+1});
            else map.setOptions({zoom:map.zoom-1});
        }
    // Tooltip
        MapClass.tooltip = {}
        MapClass.tooltip.showTooltip = function(item, show, add_to_positionX, add_to_positionY, text){
            if(add_to_positionX == undefined) add_to_positionX = 0;
            if(add_to_positionY == undefined) add_to_positionY = 0;
            if(jQuery(".map .tooltip").css("display") == "block"){
                TweenMax.to(".map .tooltip", 0.2, { alpha:0, left: parseFloat(jQuery(".map .tooltip").css("left"))+10 , display:"none", onComplete:function(){ MapClass.tooltip.showTooltip(item, show, add_to_positionX, add_to_positionY, text); }});
                return;
            }
            if(show){
                if(text != undefined) jQuery(".map .tooltip div").text( text );
                else jQuery(".map .tooltip div").text( jQuery(item).attr("title") );
                var dimentions = cuppa.dimentions(item);
                var posX = jQuery(item).offset().left + jQuery(item).width() + add_to_positionX;
                var posY = jQuery(item).offset().top + add_to_positionY;                                
                jQuery(".map .tooltip").css("left", posX + 20).css("top", posY).css("opacity", 0);
                TweenMax.to(".map .tooltip", 0.3, {alpha:1, left:posX, display:"block", ease:Cubic.easeOut});
            }
        }
    
</script>
<div class="map">
    <div id="map-canvas" class="map-canvas"></div>
    <!-- Buttons -->
        <div class="map_buttons">
            <ul>
                <li>
                    <a title="<?php echo $cuppa->language->getValue("restaurants_bars", $language); ?>" class="buttom_pin restaurant" onclick="MapClass.onClick('restaurant')" ></a>
                </li>
                <li class="separator"></li>
                <li>
                    <a title="<?php echo $cuppa->language->getValue("school", $language); ?>" class="buttom_pin school" onclick="MapClass.onClick('school')" ></a>
                </li>
                <li class="separator"></li>
                <li>
                    <a title="<?php echo $cuppa->language->getValue("wellness", $language); ?>" class="buttom_pin wellness" onclick="MapClass.onClick('wellness')" ></a>
                </li>
                <li class="separator"></li>
                <li>
                    <a title="<?php echo $cuppa->language->getValue("parks", $language); ?>" class="buttom_pin park" onclick="MapClass.onClick('park')" ></a>
                </li>
                <li class="separator"></li>
                <li>
                    <a title="<?php echo $cuppa->language->getValue("malls", $language); ?>" class="buttom_pin mall" onclick="MapClass.onClick('mall')" ></a>
                </li>
            </ul>
        </div>
    <!-- -->
    <!-- Control -->
        <div class="controls" >
            <div class="button zoom_less" onclick="MapClass.onZoom('-')" ></div>
            <div class="zoom_separator"></div>
            <div class="button zoom_more" onclick="MapClass.onZoom('+')" ></div>
        </div>
    <!-- -->
    <!-- Tooltip -->
        <div class="tooltip">
            <span class="arrow_tooltip"></span>
            <div>Text</div>
        </div>
    <!-- -->
</div>