<?php
    @session_start();
    if(!@$_SESSION["cuSession"]){ echo '<script> window.location=document.URL; </script>'; exit(); }
    include_once($_SESSION["cuSession"]->paths->administrator->document_path."classes/Cuppa.php");
    $cuppa = Cuppa::getInstance();
    if(!@$path) $path = $cuppa->dataHelp->getUrlVars(@$_POST["path"]);
    $language = $cuppa->language->load();
?>
<style>
    .alert{ position: fixed; z-index: 9999; }
    .cuppa_alert{
        position: fixed;
        display: block;
        width: 100%;
        max-width: 420px;
        padding: 10px;
        z-index: 9999;
        color: #333;
    }
    .cuppa_alert .space{
        position: relative;
        display: block;
        border-radius: 3px;
        background: #FFF;
        overflow: hidden;
        padding: 20px 30px;
        box-shadow: 0px 0px 8px rgba(0,0,0,0.1);
    }
    .cuppa_alert .btn_close{
        position: absolute;
        top: 20px;
        right: 20px;
        cursor: pointer;
        width: 13px;
        height: 13px;
        background-position: center;
        background-repeat: no-repeat;
        background-size: contain;
    }
    .cuppa_alert .text1{
        font-size: 18px;
        line-height: normal;
        font-weight: bold;
    }
    .cuppa_alert .text2{
        margin: 10px 0px 20px;
        line-height: normal;
    }
    .cuppa_alert .cuppa_alert_buttons{
        position: relative;
        text-align: center;
    }
    .cuppa_alert .btn_accept{
        border: 1px solid #3079ED;
        color: #FFF;
        border-radius: 3px;
        text-shadow: 0px 1px 1px rgba(0,0,0,0.2);
        cursor: pointer;
        background: #4d90fe;
        background: linear-gradient(to bottom,  #4d90fe 0%,#4787ee 100%);
        user-select: none;
        -moz-user-select: none;
        -webkit-user-select: none;
        height: 29px;
        padding: 0px 19px;
        text-transform: capitalize;
        width: auto;
        font-style: normal;
    }
        .cuppa_alert .btn_accept:hover{
            border: 1px solid #196AEB;
            box-shadow: 0px 1px 2px rgba(0,0,0,0.20);
            background: #4a8dfc;
            background: linear-gradient(to bottom,  #4a8dfc 0%,#337bed 100%); 
        }
        
    .cuppa_alert .btn_cancel{
        border: 1px solid #C6322A !important;
        border-radius: 3px !important;
        color: #FFF !important;
        text-shadow: 0px 1px 1px rgba(0,0,0,0.2);
        cursor: pointer;
        background: #dd4b39;
        background: linear-gradient(to bottom,  #dd4b39 0%,#dd4b39 100%); 
        user-select: none;
        -moz-user-select: none;
        -webkit-user-select: none;
        height: 29px !important;
        text-transform: capitalize;
        width: auto;
    }
        .cuppa_alert .btn_cancel:hover{
            border: 1px solid #B12D26 !important;
            box-shadow: 0px 1px 2px rgba(0,0,0,0.20) !important;
            background: #db4a38;
            background: linear-gradient(to bottom,  #db4a38 0%,#c13e2c 100%);
        }
    
    
    .cuppa_alert input[type=button]:active{
        box-shadow: inset 0px 1px 3px rgba(0,0,0,0.20) !important;
        background: #2e76e8;
    }
</style>
<script>
    cuppa_alert = {}
    //++ resize
        cuppa_alert.resize = function(){
           var dimentions = cuppa.dimentions(".cuppa_alert");
           jQuery(".cuppa_alert").css("left", ( jQuery(window).width() - dimentions.width )*0.5 );
           jQuery(".cuppa_alert").css("top", ( jQuery(window).height() - dimentions.height )*0.5 );
        }; 
    //--
    //++ accept
        cuppa_alert.accept = function(){
            cuppa.setContent({load:false, duration:0.3, name:".alert", last:true});
            cuppa.blockade({load:false, name:".blockade", duration:0.2, delay:0.2, last:true});
            cuppa.shareObject(true);
        }
    //--
    //++ close
        cuppa_alert.close = function(){
            cuppa.setContent({load:false, duration:0.3, name:".alert", last:true});
            cuppa.blockade({load:false, name:".blockade", duration:0.2, delay:0.2, last:true});
            cuppa.shareObject(false);
        }
    //--
    //++ end
        cuppa_alert.end = function(){
            cuppa.removeEventGroup("cuppa_alert");
        }; cuppa.addRemoveListener(".cuppa_alert", cuppa_alert.end);
    //--
    //++ init
        cuppa_alert.init = function(){
            cuppa.addEventListener("resize", cuppa_alert.resize, window, "cuppa_alert"); cuppa_alert.resize();
            jQuery("*").blur();
        }; cuppa.addEventListener("ready",  cuppa_alert.init, document, "cuppa_alert");
    //--
</script>
<div class="cuppa_alert">
    <div class="space">
        <?php if(@$_POST["title"]){ ?>
            <div class="text1"><?php echo $cuppa->echoString($_POST["title"]) ?></div>
        <?php } ?>
        <?php if(@$_POST["message"]){ ?>
            <div class="text2"><?php echo $cuppa->echoString($_POST["message"]) ?></div>
        <?php } ?>
        <?php if(@$_POST["hide_buttons"] != "true"){ ?>
            <div onclick="cuppa_alert.close()" class="btn_close" style="background-image: url(<?php echo $cuppa->getPath() ?>/js/cuppa/images/close_gray.png)" ></div>
            <div class="cuppa_alert_buttons">
                <button class="btn_cancel" type="button" onclick="cuppa_alert.close()" ><?php echo $cuppa->language->getValue("cancel", $language);  ?></button>
                <button class="btn_accept" type="button" onclick="cuppa_alert.accept()" ><?php echo $cuppa->language->getValue("accept", $language);  ?></button>
            </div>
        <?php } ?>
    </div>
</div>